//
//  InspectorViewGlyphController.h
//  GlyphsLayerPluginOutline
//
//  Created by Georg Seifert on 08.02.09.
//  Copyright 2009 schriftgestaltung.de. All rights reserved.
//

#import <Cocoa/Cocoa.h>
#import "GSInspectorViewController.h"

@class GSLayer;
@class GSInspectorView;
@class GSSteppingTextField;

@interface InspectorViewGlyphController : GSInspectorViewController {
	GSLayer* __weak _previousLayer;
	GSLayer* __weak _nextLayer;

	NSImage* exeption;
	NSImage* noExeption;
	NSImage* rightTransferValue;
	NSImage* leftTransferValue;
}

@property (nonatomic, weak) GSLayer* previousLayer;
@property (nonatomic, weak) GSLayer* nextLayer;
@property (nonatomic, weak) IBOutlet NSButton* leftExeptionButton;
@property (nonatomic, weak) IBOutlet NSButton* rightExeptionButton;
@property (nonatomic, weak) IBOutlet NSTextField* nameField;
@property (nonatomic, weak) IBOutlet NSTextField* unicodeField;
@property (nonatomic, weak) IBOutlet NSTextField* leftMetricsLabel;
@property (nonatomic, weak) IBOutlet GSSteppingTextField* leftMetricsField;
@property (nonatomic, weak) IBOutlet NSButton* leftMetricsSyncButton;
@property (nonatomic, weak) IBOutlet NSTextField* widthLabel;
@property (nonatomic, weak) IBOutlet NSTextField* widthField;
@property (nonatomic, weak) IBOutlet NSButton* widthMetricsSyncButton;
@property (nonatomic, weak) IBOutlet NSTextField* rightMetricsLabel;
@property (nonatomic, weak) IBOutlet GSSteppingTextField* rightMetricsField;
@property (nonatomic, weak) IBOutlet NSButton* rightMetricsSyncButton;
@property (nonatomic, weak) IBOutlet NSTextField* leftKerningField;
@property (nonatomic, weak) IBOutlet NSTextField* leftGroupField;
@property (nonatomic, weak) IBOutlet NSTextField* rightGroupField;
@property (nonatomic, weak) IBOutlet NSTextField* rightKerningField;
@property (nonatomic, weak) IBOutlet NSButton* showInUnicodeCheckerButton;
@property (nonatomic, weak) IBOutlet NSPopUpButton* colorLabelPopup;
@property (nonatomic, weak) IBOutlet GSInspectorView* nameBackgroundView;

@property (nonatomic, weak) IBOutlet NSLayoutConstraint* LSBRightConstraint;
@property (nonatomic, weak) IBOutlet NSLayoutConstraint* RSBLeftConstraint;

- (IBAction)showInUnicodeChecker:(id)sender;

#ifndef GLYPHS_VIEWER

- (void)setAlternateButtons:(NSNotification*)theNotifivation;

- (IBAction)setName:(id)sender;

- (IBAction)setLeftMetricsKey:(id)sender;

- (IBAction)setRightMetricsKey:(id)sender;

- (IBAction)setWidth:(id)sender;

- (IBAction)setLeftKerning:(id)sender;

- (IBAction)setLeftGroup:(id)sender;

- (IBAction)setLeftExeption:(id)sender;

- (IBAction)setRightKerning:(id)sender;

- (IBAction)setRightGroup:(id)sender;

- (IBAction)setRightExeption:(id)sender;
#endif
@end
